%global maintainer              cpuhouse
%global _hardened_build         1

%global libname                 liburing
%global libsoname               %{expand:%(echo %{libname} | sed 's/^lib//g')}

Name:    %{libname}
Version: 0.6
Release: 2%{?dist}~%{maintainer}
Summary: Linux-native io_uring I/O access library
License: (GPLv2 with exceptions and LGPLv2+) or MIT
URL:     https://git.kernel.dk/cgit/liburing/

Source0: https://brick.kernel.dk/snaps/%{name}-%{version}.tar.gz
Source1: https://brick.kernel.dk/snaps/%{name}-%{version}.tar.gz.asc

BuildRequires: gcc

# Fails to build and therefore isn't supported upstream
ExcludeArch: armv7hl

%description
Provides native async IO for the Linux kernel, in a fast and efficient
manner, for both buffered and O_DIRECT.

%package devel
Summary: Development files for Linux-native io_uring I/O access library
Requires: %{name}%{_isa} = %{version}-%{release}
Requires: pkgconfig

%description devel
This package provides header files to include and libraries to link with
for the Linux-native io_uring.

%package static
Summary: Static libraries for Linux-native io_uring I/O access library
Requires: %{name}-devel%{_isa} = %{version}-%{release}

%description static
The liburing-static package includes static libraries needed
to develop programs that use Linux-native io_uring.


%prep
%autosetup


%build
%set_build_flags
./configure \
  --prefix=%{_prefix} \
  --libdir=/%{_libdir} \
  --libdevdir=/%{_libdir} \
  --mandir=%{_mandir} \
  --includedir=%{_includedir}

%make_build


%check
make test


%install
%make_install

%{__ln_s} %{_libdir}/pkgconfig/%{libname}.pc \
          %{buildroot}%{_libdir}/pkgconfig/%{libsoname}.pc


%ldconfig_scriptlets


%files
%license COPYING
%{_libdir}/%{libname}.so.*

%files devel
%license COPYING
%{_includedir}/liburing.h
%dir %{_includedir}/%{libname}
%{_includedir}/%{libname}/io_uring.h
%{_includedir}/%{libname}/compat.h
%{_includedir}/%{libname}/barrier.h
%{_libdir}/%{libname}.so
%{_libdir}/pkgconfig/%{libname}.pc
%{_libdir}/pkgconfig/%{libsoname}.pc
%{_mandir}/man2/io_uring_enter.2*
%{_mandir}/man2/io_uring_register.2*
%{_mandir}/man2/io_uring_setup.2*

%files static
%license COPYING
%{_libdir}/%{libname}.a


%changelog
* Thu Jul 02 2020 Cpuhouse DevTeam <devel@cpuhouse.com.br> - 0.6-2
- Enabled hardened build

* Fri Jun 05 2020 Cpuhouse DevTeam <devel@cpuhouse.com.br> - 0.6-1
- Spec file forked from Fedora (Stefan Hajnoczi <stefanha@redhat.com>)

# vim:number:sw=4:sts=4:ts=4:et:autoindent:syntax=spec
